#include <wait.h>
#include "libnazgul.h"

int main(void) {
  //	msgSpace mS=0;

  msgSpaceId testId;
  msgSpace * mSPAC;
  msgPool poolInfos[3];
  char * montext;

  poolInfos[0].bufferNb=4;
  poolInfos[0].bufferSize=200;
  
  poolInfos[1].bufferNb=5;
  poolInfos[1].bufferSize=250;

  poolInfos[2].bufferNb=3;
  poolInfos[2].bufferSize=280;
  
  strcpy(testId,"test");
  printf("RequestedId: %s\n",testId);
  
  mSPAC=msgSpaceCreate(testId,0,3,poolInfos);
 
  pid_t pid=fork();
  
  
  
  if (pid ==0){
	mSPAC=msgSpaceOpen(testId);
	sleep(2);
	montext=msgAllocate(mSPAC,2,180,0); 
	printf("ALLOC %d.. ok\n",(int)getpid());
	sleep(2);
	montext=msgAllocate(mSPAC,2,170,0); 
	printf("ALLOC %d.. ok\n",(int)getpid());
	sleep(2);
	montext=msgAllocate(mSPAC,2,270,0);
	printf("ALLOC %d.. ok\n",(int)getpid());
	
  } else {
	mSPAC=msgSpaceOpen(testId);
	montext=msgAllocate(mSPAC,2,280,0); 
	printf("ALLOC %d.. ok\n",(int)getpid());
	sleep(2);
	montext=msgAllocate(mSPAC,2,270,0); 
	printf("ALLOC %d.. ok\n",(int)getpid());
	sleep(2);
	montext=msgAllocate(mSPAC,2,270,0);
	printf("ALLOC %d.. ok\n",(int)getpid());
	//msgFree(mSPAC,(void *)montext);
	//msgFree(mSPAC,(void *)montext);
	//msgFree(mSPAC,(void *)montext);
	wait(NULL);
	msgSpaceDelete(testId);
  }
  return 0;
}
